Index: /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.env
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.env	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.env	(revision 2191)
@@ -0,0 +1,11 @@
+module purge
+module load flavor/buildcompiler/gcc/8
+module load mpi/openmpi/4.0.2 
+
+module load flavor/hdf5/parallel
+module load netcdf-fortran/4.4.4
+module load hdf5/1.8.20
+module load gnu/8.3.0
+
+module load totalview
+module load perl/5.30.2
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.fcm
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.fcm	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.fcm	(revision 2191)
@@ -0,0 +1,26 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90
+
+%BASE_CFLAGS    -std=c++11 -w -fpermissive -D__XIOS_EXCEPTION
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -fbacktrace
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -fbacktrace -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ --free-form -ffree-line-length-0
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -fbacktrace
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -fbacktrace
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            cpp
+%FPP            cpp -P
+%MAKE           gmake
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.path
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.path	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE_GNU.path	(revision 2191)
@@ -0,0 +1,28 @@
+NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR"
+NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR"
+NETCDF_LIB="-lnetcdf -lnetcdff"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INCDIR"
+HDF5_LIBDIR="-L$HDF5_LIBDIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.env
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.env	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.env	(revision 2191)
@@ -0,0 +1,11 @@
+module purge
+module load flavor/buildcompiler/gcc/8
+module load mpi/openmpi/4.0.2 
+
+module load flavor/hdf5/parallel
+module load netcdf-fortran/4.4.4
+module load hdf5/1.8.20
+module load gnu/8.3.0
+
+module load totalview
+module load perl/5.30.2
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.fcm
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.fcm	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.fcm	(revision 2191)
@@ -0,0 +1,26 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90
+
+%BASE_CFLAGS    -std=c++11 -w -fpermissive -D__XIOS_EXCEPTION
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -fbacktrace
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -fbacktrace -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ --free-form -ffree-line-length-0
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -fbacktrace
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -fbacktrace
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            cpp
+%FPP            cpp -P
+%MAKE           gmake
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.path
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.path	(revision 2191)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_IRENE_GNU.path	(revision 2191)
@@ -0,0 +1,28 @@
+NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR"
+NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR"
+NETCDF_LIB="-lnetcdf -lnetcdff"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INCDIR"
+HDF5_LIBDIR="-L$HDF5_LIBDIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_irene.def
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_irene.def	(revision 2190)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_irene.def	(revision 2191)
@@ -1,2 +1,4 @@
-arch = X64_IRENE
+arch = X64_IRENE, X64_IRENE_GNU
 mode = prod
+#arch = X64_IRENE_GNU
+#mode = debug
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_irene
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_irene	(revision 2190)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_irene	(revision 2191)
@@ -3,4 +3,10 @@
 export arch=X64_IRENE
 export mode=prod
+
+bash ./run_test
+
+
+export arch=X64_IRENE_GNU
+export mode=debug
 
 bash ./run_test