Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.cpp	(revision 2193)
@@ -1,3 +1,4 @@
 #include "binary_arithmetic_filter.hpp"
+#include "workflow_graph.hpp"
 
 namespace xios
@@ -9,4 +10,53 @@
   { /* Nothing to do */ };
 
+  std::pair<int, int> CScalarFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->graphEnabled;
+    int unique_filter_id;
+    bool firstround = true;
+    
+    if(building_graph)
+    {
+      if(!data[0]->graphPackage)
+      {
+        data[0]->graphPackage = new CGraphDataPackage;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        data[0]->graphPackage->fromFilter = -1;
+      }
+
+      if(!CWorkflowGraph::mapHashFilterID_) CWorkflowGraph::mapHashFilterID_ = new std::unordered_map <size_t, int>;
+
+      size_t filterhash = std::hash<StdString>{}(this->graphPackage->inFields[0]->content+to_string(data[0]->timestamp)+this->graphPackage->inFields[0]->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_->find(filterhash) == CWorkflowGraph::mapHashFilterID_->end())
+      {
+        this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+        unique_filter_id = this->graphPackage->filterId;
+        CWorkflowGraph::addNode("Arithmetic filter\\n ("+this->graphPackage->inFields[0]->content+")", 4, false, 0, data[0]);        
+
+        CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, this->graphPackage->filterId, data[0]);
+        data[0]->graphPackage->fromFilter = this->graphPackage->filterId;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+
+       
+        (*CWorkflowGraph::mapHashFilterID_)[filterhash] = unique_filter_id; 
+        
+      }
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_)[filterhash];
+        if(data[0]->graphPackage->fromFilter != unique_filter_id)
+        {
+          CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, unique_filter_id, data[0]);  
+        }
+      }  
+    }
+
+    return std::make_pair(building_graph, unique_filter_id);
+  }
+
   CDataPacketPtr CScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
@@ -15,4 +65,13 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::pair<int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph))
+    {  
+      packet->graphPackage = new CGraphDataPackage;
+      packet->graphPackage->fromFilter = std::get<1>(graph);
+      packet->graphPackage->currentField = this->graphPackage->inFields[0]; 
+    }
 
     if (packet->status == CDataPacket::NO_ERROR)
@@ -28,4 +87,53 @@
   { /* Nothing to do */ };
 
+  std::pair<int, int> CFieldScalarArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->graphEnabled;
+    int unique_filter_id;
+    bool firstround = true;
+
+    if(building_graph)
+    {
+      if(!data[0]->graphPackage)
+      {
+        data[0]->graphPackage = new CGraphDataPackage;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        data[0]->graphPackage->fromFilter = -1;
+      }
+
+      if(!CWorkflowGraph::mapHashFilterID_) CWorkflowGraph::mapHashFilterID_ = new std::unordered_map <size_t, int>;
+
+      size_t filterhash = std::hash<StdString>{}(this->graphPackage->inFields[0]->content+to_string(data[0]->timestamp)+this->graphPackage->inFields[0]->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_->find(filterhash) == CWorkflowGraph::mapHashFilterID_->end())
+      {
+        this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+        unique_filter_id = this->graphPackage->filterId;
+        CWorkflowGraph::addNode("Arithmetic filter\\n ("+this->graphPackage->inFields[0]->content+")", 4, false, 0, data[0]);        
+
+        CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, this->graphPackage->filterId, data[0]);
+        data[0]->graphPackage->fromFilter = this->graphPackage->filterId;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+
+       
+        (*CWorkflowGraph::mapHashFilterID_)[filterhash] = unique_filter_id; 
+        
+      }
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_)[filterhash];
+        if(data[0]->graphPackage->fromFilter != unique_filter_id)
+        {
+          CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, unique_filter_id, data[0]);  
+        }
+      }  
+    }
+
+    return std::make_pair(building_graph, unique_filter_id);
+  }
+
   CDataPacketPtr CFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
@@ -35,4 +143,13 @@
     packet->status = data[0]->status;
 
+    std::pair<int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph))
+    {  
+      packet->graphPackage = new CGraphDataPackage;
+      packet->graphPackage->fromFilter = std::get<1>(graph);
+      packet->graphPackage->currentField = this->graphPackage->inFields[0]; 
+    }
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(data[0]->data, value));
@@ -46,4 +163,68 @@
   { /* Nothing to do */ };
 
+  std::pair<int, int> CFieldFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->graphEnabled;
+    int unique_filter_id;
+    bool firstround = true;
+
+    if(building_graph)
+    {
+      if(!data[0]->graphPackage)
+      {
+        data[0]->graphPackage = new CGraphDataPackage;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        data[0]->graphPackage->fromFilter = -1;
+      }
+      if(!data[1]->graphPackage)
+      {
+        data[1]->graphPackage = new CGraphDataPackage;
+        data[1]->graphPackage->currentField = this->graphPackage->inFields[0];
+        data[1]->graphPackage->fromFilter = -1;
+      }
+
+      if(!CWorkflowGraph::mapHashFilterID_) CWorkflowGraph::mapHashFilterID_ = new std::unordered_map <size_t, int>;
+
+      size_t filterhash = std::hash<StdString>{}(this->graphPackage->inFields[0]->content+to_string(data[0]->timestamp)+this->graphPackage->inFields[0]->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_->find(filterhash) == CWorkflowGraph::mapHashFilterID_->end())
+      {
+        this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+        unique_filter_id = this->graphPackage->filterId;
+        CWorkflowGraph::addNode("Arithmetic filter\\n ("+this->graphPackage->inFields[0]->content+")", 4, false, 0, data[0]);        
+
+        CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, this->graphPackage->filterId, data[0]);
+        data[0]->graphPackage->fromFilter = this->graphPackage->filterId;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+
+        CWorkflowGraph::addEdge(data[1]->graphPackage->fromFilter, this->graphPackage->filterId, data[1]);
+        data[1]->graphPackage->fromFilter = this->graphPackage->filterId;
+        data[1]->graphPackage->currentField = this->graphPackage->inFields[0];
+
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+
+        (*CWorkflowGraph::mapHashFilterID_)[filterhash] = unique_filter_id; 
+        
+      }
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_)[filterhash];
+        if(data[0]->graphPackage->fromFilter != unique_filter_id)
+        {
+          CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, unique_filter_id, data[0]);  
+        }
+        if(data[1]->graphPackage->fromFilter != unique_filter_id)
+        {
+          CWorkflowGraph::addEdge(data[1]->graphPackage->fromFilter, unique_filter_id, data[1]);  
+        }
+      }  
+    }
+
+    return std::make_pair(building_graph, unique_filter_id);
+  }
+
+
   CDataPacketPtr CFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
@@ -51,4 +232,13 @@
     packet->date = data[0]->date;
     packet->timestamp = data[0]->timestamp;
+
+    std::pair<int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph))
+    {  
+      packet->graphPackage = new CGraphDataPackage;
+      packet->graphPackage->fromFilter = std::get<1>(graph);
+      packet->graphPackage->currentField = this->graphPackage->inFields[0]; 
+    }
 
     if (data[0]->status != CDataPacket::NO_ERROR)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.hpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/binary_arithmetic_filter.hpp	(revision 2193)
@@ -35,4 +35,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::pair<int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CScalarFieldArithmeticFilter
 
@@ -63,4 +64,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::pair<int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldScalarArithmeticFilter
 
@@ -89,4 +91,6 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::pair<int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
+      
   }; // class CFieldFieldArithmeticFilter
 } // namespace xios
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.cpp	(revision 2193)
@@ -30,5 +30,11 @@
     , isFirstOperation(true)
     , graphCycleCompleted(true)
+    , temporalOperation(opId)
   {
+  }
+
+  std::string CTemporalFilter::getTemporalOperation()
+  {
+    return this->temporalOperation;
   }
 
@@ -45,5 +51,5 @@
       {  
         this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
-        CWorkflowGraph::addNode("Temporal filter", 3, false, 0, data[0]);
+        CWorkflowGraph::addNode("Temporal filter \\n("+getTemporalOperation()+")", 3, false, 0, data[0]);
         graphCycleCompleted = false;
       }
@@ -54,5 +60,5 @@
       CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, this->graphPackage->filterId, data[0]);
       data[0]->graphPackage->fromFilter = this->graphPackage->filterId;
-      this->graphPackage->sourceFilterIds.push_back(data[0]->graphPackage->fromFilter); 
+      // this->graphPackage->sourceFilterIds.push_back(data[0]->graphPackage->fromFilter); 
       data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
       std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.hpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/temporal_filter.hpp	(revision 2193)
@@ -55,4 +55,5 @@
       bool virtual isDataExpected(const CDate& date) const;
       bool graphCycleCompleted;
+      std::string getTemporalOperation();
 
     private:
@@ -73,4 +74,5 @@
 //      CDate nextOperationDate; //!< The date of the next operation
       bool isFirstOperation; //!< True before the first operation was been computed
+      const std::string temporalOperation;
   }; // class CTemporalFilter
 } // namespace xios
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.cpp	(revision 2193)
@@ -1,3 +1,5 @@
 #include "unary_arithmetic_filter.hpp"
+#include "workflow_graph.hpp"
+
 
 namespace xios
@@ -8,4 +10,54 @@
   { /* Nothing to do */ };
 
+  std::pair<int, int> CUnaryArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->graphEnabled;
+    int unique_filter_id;
+    bool firstround = true;
+    
+    if(building_graph)
+    {
+      if(!data[0]->graphPackage)
+      {
+        data[0]->graphPackage = new CGraphDataPackage;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        data[0]->graphPackage->fromFilter = -1;
+      }
+
+      if(!CWorkflowGraph::mapHashFilterID_) CWorkflowGraph::mapHashFilterID_ = new std::unordered_map <size_t, int>;
+
+      size_t filterhash = std::hash<StdString>{}(this->graphPackage->inFields[0]->content+to_string(data[0]->timestamp)+this->graphPackage->inFields[0]->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_->find(filterhash) == CWorkflowGraph::mapHashFilterID_->end())
+      {
+        this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+        unique_filter_id = this->graphPackage->filterId;
+        CWorkflowGraph::addNode("Arithmetic filter\\n ("+this->graphPackage->inFields[0]->content+")", 4, false, 0, data[0]);        
+
+        CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, this->graphPackage->filterId, data[0]);
+        data[0]->graphPackage->fromFilter = this->graphPackage->filterId;
+        data[0]->graphPackage->currentField = this->graphPackage->inFields[0];
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+
+       
+        (*CWorkflowGraph::mapHashFilterID_)[filterhash] = unique_filter_id; 
+        
+      }
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_)[filterhash];
+        if(data[0]->graphPackage->fromFilter != unique_filter_id)
+        {
+          CWorkflowGraph::addEdge(data[0]->graphPackage->fromFilter, unique_filter_id, data[0]);  
+        }
+      }  
+    }
+
+    return std::make_pair(building_graph, unique_filter_id);
+  }
+
+
   CDataPacketPtr CUnaryArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
@@ -15,4 +67,13 @@
     packet->status = data[0]->status;
 
+    std::pair<int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph))
+    {  
+      packet->graphPackage = new CGraphDataPackage;
+      packet->graphPackage->fromFilter = std::get<1>(graph);
+      packet->graphPackage->currentField = this->graphPackage->inFields[0]; 
+    }
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(data[0]->data));
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.hpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/unary_arithmetic_filter.hpp	(revision 2193)
@@ -34,4 +34,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::pair<int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CUnaryArithmeticFilter
 } // namespace xios
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/graph_package.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/graph_package.hpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/graph_package.hpp	(revision 2193)
@@ -12,4 +12,5 @@
     StdString contextId;
     bool show;
+    std::pair< Time, Time > graphInterval;
 
     CGraphPackage(): show(true) {}
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 2193)
@@ -559,16 +559,16 @@
   {
     if (buildWorkflowGraphDone_) return true ;
+
     
     const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
     const double defaultValue = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
     bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
-    info(100)<<"=== Workflow Graph === field id="<<this->getId()<<" build_workflow_graph="<<buildGraph_<<std::endl;
+
     if (!inputFilter) inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc)); 
-     
+    
     if (hasDirectFieldReference())
     {
       CField* fieldRef = getDirectFieldReference();
-      info(100)<<"=== Workflow Graph === fieldRef id="<<fieldRef->getId()<<std::endl;
-
+      
       //------ build_workflow_graph start
       if(buildGraph_)
@@ -580,9 +580,8 @@
         this->build_workflow_graph.set(fieldRef->build_workflow_graph);
         buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
-        info(100)<<"=== Workflow Graph === field id="<<this->getId()<<" updated build_workflow_graph="<<buildGraph_<<std::endl;
       }
 
       
-      if(buildGraph_) this->build_workflow_graph.set(build_workflow_graph);
+      // if(buildGraph_) this->build_workflow_graph.set(build_workflow_graph);
       //------ build_workflow_graph end
 
@@ -604,4 +603,6 @@
       boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
       filterExpr = expr->reduce(gc, *this);
+      
+      
       if (!filterExpr) return false ; // workflow graph cannot be built at this stage
     }
@@ -636,5 +637,4 @@
       if(buildGraph_) 
       {
-        info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a transformation filter 2 ============== "<<getDirectFieldReference()->getInstantDataFilter()<<" _ "<<inputFilter<<std::endl;
         inputFilter->graphEnabled=true;
         inputFilter->graphPackage = new CGraphPackage;
@@ -648,5 +648,8 @@
       if (hasExpression())
       {
-         if (filterExpr) lastFilter=filterExpr ;
+         if (filterExpr) 
+         {
+           lastFilter=filterExpr ;
+         }
       }
       
@@ -716,5 +719,4 @@
     if(buildGraph_) 
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToFileServer  ============== "<<getTemporalDataFilter(gc, fileOut_->output_freq)<<" _ "<<clientToServerStoreFilter_<<std::endl;
       clientToServerStoreFilter_->graphPackage = new CGraphPackage;
       clientToServerStoreFilter_->graphEnabled = true;
@@ -731,5 +733,4 @@
     if(buildGraph_) 
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToCouplerOut  ============== "<<instantDataFilter<<" _ "<<clientToServerStoreFilter_<<std::endl;
       clientToServerStoreFilter_->graphPackage = new CGraphPackage;
       clientToServerStoreFilter_->graphEnabled = true;
@@ -753,5 +754,4 @@
     if(buildGraph_ ) 
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToModelInput  ============== "<<modelToClientSourceFilter_<<" _ "<<inputFilter<<" ***** "<<std::endl;
       modelToClientSourceFilter_->graphPackage = new CGraphPackage;
       modelToClientSourceFilter_->graphEnabled = true;
@@ -770,5 +770,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToClientInput  ============== "<<serverFromClientSourceFilter_ << " _ "<<inputFilter<<" ***** "<<std::endl;
       serverFromClientSourceFilter_->graphPackage = new CGraphPackage;
       serverFromClientSourceFilter_->graphEnabled = true;
@@ -789,5 +788,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToServerInput  ============== "<<clientFromServerSourceFilter_ << " _ "<<inputFilter<<std::endl;
       clientFromServerSourceFilter_->graphPackage = new CGraphPackage;
       clientFromServerSourceFilter_->graphEnabled = true;
@@ -810,5 +808,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToCouplerIn  ============== "<<clientFromClientSourceFilter_ << " _ "<<inputFilter<<std::endl;
       clientFromClientSourceFilter_->graphPackage = new CGraphPackage;
       clientFromClientSourceFilter_->graphEnabled = true;
@@ -827,5 +824,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToFileWriter  ============== "<<instantDataFilter << " _ "<<fileWriterStoreFilter_<<std::endl;
       fileWriterStoreFilter_->graphPackage = new CGraphPackage;
       fileWriterStoreFilter_->graphEnabled = true;
@@ -844,5 +840,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToFileReader  ============== "<<fileReaderSourceFilter_ << " _ "<<inputFilter<<std::endl;
       fileReaderSourceFilter_->graphPackage = new CGraphPackage;
       fileReaderSourceFilter_->graphEnabled = true;
@@ -862,5 +857,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToModelOutput  ============== "<<instantDataFilter << " _ "<<clientToModelStoreFilter_<<std::endl;
       clientToModelStoreFilter_->graphPackage = new CGraphPackage;
       clientToModelStoreFilter_->graphEnabled = true;
@@ -878,5 +872,4 @@
     if(buildGraph_)
     {
-      info(100)<<"=== Workflow Graph === field "<<this->getId()<<" calls a connectToServerToClient  ============== "<<instantDataFilter << " _ "<<serverToClientStoreFilter_<<std::endl;
       serverToClientStoreFilter_->graphPackage = new CGraphPackage;
       serverToClientStoreFilter_->graphEnabled = true;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp	(revision 2193)
@@ -41,5 +41,7 @@
 
         bool ret=field->buildWorkflowGraph(gc);
+        if(field->build_workflow_graph) thisField.build_workflow_graph.set(field->build_workflow_graph);
         if (ret) outputPin = field->getInstantDataFilter(); // if dependency is complete build the graph other return nullptr
+        
       }
       else ERROR("boost::shared_ptr<COutputPin> CFilterFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const",
@@ -110,4 +112,13 @@
     if (ret) ret->connectOutput(filter, 0);
     else filter.reset() ;
+    
+    const bool buildGraph_ = !(thisField.build_workflow_graph.isEmpty()) && thisField.build_workflow_graph == true ;
+    if(buildGraph_)
+    {
+      filter->graphPackage = new CGraphPackage;
+      filter->graphEnabled = true;
+      filter->graphPackage->inFields.push_back(&thisField);
+    }
+
     return filter;
   }
@@ -130,4 +141,13 @@
     if (ret) ret->connectOutput(filter, 0);
     else filter.reset() ;
+    
+    const bool buildGraph_ = !(thisField.build_workflow_graph.isEmpty()) && thisField.build_workflow_graph == true ;
+    if(buildGraph_)
+    {
+      filter->graphPackage = new CGraphPackage;
+      filter->graphEnabled = true;
+      filter->graphPackage->inFields.push_back(&thisField);
+    }
+
     return filter;
   }
@@ -149,4 +169,12 @@
     if (ret) ret->connectOutput(filter, 0);
     else filter.reset() ;
+    
+    const bool buildGraph_ = !(thisField.build_workflow_graph.isEmpty()) && thisField.build_workflow_graph == true ;
+    if(buildGraph_)
+    {
+      filter->graphPackage = new CGraphPackage;
+      filter->graphEnabled = true;
+      filter->graphPackage->inFields.push_back(&thisField);
+    }
     return filter;
   }
@@ -173,4 +201,13 @@
     }
     else filter.reset() ;
+
+    const bool buildGraph_ = !(thisField.build_workflow_graph.isEmpty()) && thisField.build_workflow_graph == true ;
+    if(buildGraph_)
+    {
+      filter->graphPackage = new CGraphPackage;
+      filter->graphEnabled = true;
+      filter->graphPackage->inFields.push_back(&thisField);
+    }
+
     return filter;
   }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.cpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.cpp	(revision 2193)
@@ -17,4 +17,7 @@
   bool CWorkflowGraph::build_begin = false;
 
+  std::unordered_map <size_t, int> *CWorkflowGraph::mapHashFilterID_ = 0;
+  std::unordered_map <size_t, int> *CWorkflowGraph::mapHashFilterID_srv_ = 0;
+
 
   CWorkflowGraph::CWorkflowGraph()
@@ -29,4 +32,5 @@
     for(int i=0; i<vectorOfNodes_->size(); i++)
     {
+      std::cout<<"Node["<<i<<"] is "<<(*vectorOfNodes_)[i].filter_name<<std::endl;
       info(100)<<"Node["<<i<<"] is "<<(*vectorOfNodes_)[i].filter_name<<std::endl;
     }
@@ -34,4 +38,5 @@
     for(int i=0; i<vectorOfEdges_->size(); i++)
     {
+      std::cout<<"Edge["<<i<<"] from "<<(*vectorOfEdges_)[i].from<<" to "<<(*vectorOfEdges_)[i].to<<std::endl;
       info(100)<<"Edge["<<i<<"] from "<<(*vectorOfEdges_)[i].from<<" to "<<(*vectorOfEdges_)[i].to<<std::endl;
     }
@@ -85,4 +90,6 @@
     if(CXios::isClient)
     {
+      // if(vectorOfEdges_&&vectorOfNodes_) outputWorkflowGraph_client_stdout();
+      // std::cout<<"Trying to add an edge from "<<from<<" to "<<to<<std::endl;
       if(!vectorOfEdges_) vectorOfEdges_ = new std::vector<graph_edge_object>;
       std::string currentContextId = CContext::getCurrent()->getId();
@@ -158,6 +165,10 @@
     if(CXios::isClient)
     {
+      //if(vectorOfEdges_&&vectorOfNodes_) outputWorkflowGraph_client_stdout();
+      // std::cout<<"Trying to add a node naming "<<filterName<<std::endl;
       if(!vectorOfNodes_) vectorOfNodes_ = new std::vector<graph_node_object>;
       if(!vectorOfContexts_) vectorOfContexts_ = new std::vector<StdString>;
+      if(!mapHashFilterID_) mapHashFilterID_ = new std::unordered_map <size_t, int>;
+
       std::string currentContextId = CContext::getCurrent()->getId();
       if ( std::find(vectorOfContexts_->begin(), vectorOfContexts_->end(), currentContextId) == vectorOfContexts_->end() )
@@ -172,4 +183,5 @@
       node_obj.date = packet->date;
       node_obj.timestamp = packet->timestamp;
+      
       for(int i=0; i<vectorOfContexts_->size(); i++)
       {
@@ -181,8 +193,8 @@
         }
       }    
+      
       node_obj.attributes = packet->graphPackage->currentField->recordXiosAttributes();
-
+      
       vectorOfNodes_->push_back(node_obj);
-      //info(100)<<"****************** Add node "<<filterName<<std::endl;   
     }
     else
@@ -190,4 +202,6 @@
       if(!vectorOfNodes_srv_) vectorOfNodes_srv_ = new std::vector<graph_node_object>;
       if(!vectorOfContexts_srv_) vectorOfContexts_srv_ = new std::vector<StdString>;
+      if(!mapHashFilterID_srv_) mapHashFilterID_srv_ = new std::unordered_map <size_t, int>;
+
       std::string currentContextId = CContext::getCurrent()->getId();
       if ( std::find(vectorOfContexts_srv_->begin(), vectorOfContexts_srv_->end(), currentContextId) == vectorOfContexts_srv_->end() )
@@ -213,5 +227,4 @@
 
       vectorOfNodes_srv_->push_back(node_obj);
-      //info(100)<<"******************Server side : Add node "<<filterName<<std::endl; 
     }
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.hpp	(revision 2192)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/workflow_graph.hpp	(revision 2193)
@@ -78,4 +78,7 @@
       static std::vector<StdString> *vectorOfContexts_srv_; 
 
+      static std::unordered_map <size_t, int> *mapHashFilterID_;
+      static std::unordered_map <size_t, int> *mapHashFilterID_srv_;
+
       // these variables are not yet used
       static bool clientGraphBuilt;