Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_jeanzay
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_jeanzay	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_jeanzay	(revision 2210)
@@ -1,4 +1,4 @@
 #!/bin/bash
-set -x 
+#set -x 
 export revision=$(svn info --show-item revision .. 2>&1)
 python config_compile.py
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ENV/jeanzay.env
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ENV/jeanzay.env	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ENV/jeanzay.env	(revision 2210)
@@ -1,5 +1,6 @@
-module load subversion
-module load cmake
-module load python/3.7.5
+module load subversion   2>&1
+module load cmake        2>&1
+module load python/3.7.5 2>&1
+module load cdo/1.9.8    2>&1
 
 CHMOD() { setfacl -m u::rwX,u:rpsl565:rwX,u:rpsl954:rwX,u:rgzi016:rwX,g::r-X,o::r-X,m::rwX "$@" ;}
@@ -12,8 +13,9 @@
 
 export ref_location=/gpfswork/rech/psl/rpsl954/reference_dir
+export ref_location=/gpfswork/rech/psl/uim55ri/CI/reference/XIOS_COUPLING
 export ref_file=reference.tar.gz
 
 export PYTHON=python
-export user_account="wuu@cpu"
+export user_account="psl@cpu"
 
 mkdir -p $xios_test_suite_repository ; CHMOD $xios_test_suite_repository
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/my_run.sh
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/my_run.sh	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/my_run.sh	(revision 2210)
@@ -44,5 +44,5 @@
   jobid="${cmd//[!0-9]/}"
   i=0
-  output=$(squeue -u rpsl954 | grep ${jobid})
+  output=$(squeue -u uim55ri | grep ${jobid})
   while [ ! -z "$output" ]
   do
@@ -50,5 +50,9 @@
     sleep 30
     ((i+=30))
-    output=$(squeue -u rpsl954 | grep ${jobid})
+    if [[ $i -eq 300 ]]; then
+      output=$(squeue -u uim55ri | grep ${jobid})
+      scancel $jobid
+      break
+    fi
   done
 fi
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test	(revision 2210)
@@ -18,4 +18,5 @@
   echo "#SBATCH --account="$user_account  >> compile.sh
   echo "#SBATCH --job-name=XIOS_rev"$svnR >> compile.sh
+  echo "#SBATCH --exclusive " >> compile.sh
   echo "cd \${SLURM_SUBMIT_DIR}">> compile.sh
   echo "ulimit -c 0">> compile.sh
@@ -24,5 +25,5 @@
   cmd=$(sbatch compile.sh)
   jobid="${cmd//[!0-9]/}"
-  output=$(squeue -u rpsl954 | grep ${jobid})
+  output=$(squeue -u uim55ri | grep ${jobid})
   while [ ! -z "$output" ]
   do
@@ -30,5 +31,5 @@
     sleep 30
     ((i+=30))
-    output=$(squeue -u rpsl954 | grep ${jobid})
+    output=$(squeue -u uim55ri | grep ${jobid})
   done
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2210)
@@ -85,4 +85,5 @@
             fh.write("#SBATCH -t 00:10:00\n")
             fh.write("#SBATCH --account="+user_acct+"\n")
+            fh.write("#SBATCH --exclusive\n")
             fh.write("ulimit -c 0\n")
             fh.write("cd ${SLURM_SUBMIT_DIR}\n")
@@ -146,4 +147,5 @@
             fh.write("#SBATCH --account="+user_acct+"\n")
             fh.write("#SBATCH --job-name=XIOS_rev"+svnR+"\n")
+            fh.write("#SBATCH --exclusive\n")
             fh.write("ulimit -c 0\n")
             fh.write("cd ${SLURM_SUBMIT_DIR}\n")
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step2.py
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step2.py	(revision 2209)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step2.py	(revision 2210)
@@ -82,5 +82,5 @@
                 for checkfile in checkfiles:
                     if os.path.exists(config+"/"+checkfile) and os.path.exists("reference/ref_"+config+"/"+checkfile):
-                        OSinfo("cdo -W diffn "+config+"/"+checkfile+" "+"reference/ref_"+config+"/"+checkfile+"  2>&1 |grep -v 'Found more than one time variable'|grep -v 'cdo diffn: Processed'|grep -v 'Time variable >time_counter< not found!' > diff_"+checkfile+".txt")
+                        OSinfo("cdo -W diffn "+config+"/"+checkfile+" "+"reference/ref_"+config+"/"+checkfile+"  2>&1 |grep -v 'Found more than one time variable'|grep -v 'cdo diffn: Processed'|grep -v 'cdo    diffn: Processed'|grep -v 'Time variable >time_counter< not found!' > diff_"+checkfile+".txt")
                         if os.stat("diff_"+checkfile+".txt").st_size==0: # if no diff -> set 0
                             report.write(folder_name+" "+folder_name+"@"+config_name+" "+folder_name+"@"+config_name+"@"+checkfile+" "+str(1)+"\n")