Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.env
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.env	(revision 2211)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.env	(revision 2211)
@@ -0,0 +1,17 @@
+module purge
+
+module load gcc/9.1.0
+module load pgi/20.4
+module load openmpi/4.0.4
+module load hdf5/1.12.0-mpi
+module load netcdf-c/4.7.4-mpi
+#module load netcdf-fortran/4.5.2-mpi-cuda
+
+#PGI use gcc/4.8.5 STL which is not good
+makelocalrc -x -d . -gcc `which gcc` -gpp `which g++`  -g77 `which gfortran`
+export PGI_LOCALRC=$PWD/localrc
+#export PGI_LOCALRC=/gpfswork/rech/psl/uim55ri/XIOS.Src/XIOS_PGI/localrc
+#export PGI_LOCALRC=/linkhome/rech/genmdl01/uim55ri/localrc
+export TMP=/dev/shm    # to compile on node with enough memory
+export TMPDIR=/dev/shm    # to compile on node with enough memory
+
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.fcm
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.fcm	(revision 2211)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.fcm	(revision 2211)
@@ -0,0 +1,25 @@
+################################################################################
+####################                Projet XIOS               ###################
+#################################################################################
+
+
+%CCOMPILER      mpicxx -noswitcherror
+%FCOMPILER      mpif90 -noswitcherror
+%LINKER         mpif90  -noswitcherror
+
+%BASE_CFLAGS    --c++11 -D__NONE__
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS -w -v
+%DEV_CFLAGS     -g -traceback
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2 -traceback
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -c++libs 
+
+%CPP            cpp 
+%FPP            cpp -P
+%MAKE           gmake
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.path
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.path	(revision 2211)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/ARCH/arch-X64_JEANZAY_PGI.path	(revision 2211)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="$(nc-config --cflags)"
+NETCDF_LIBDIR=$(nc-config --libs)
+NETCDF_LIB=""
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_jeanzay.def
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_jeanzay.def	(revision 2210)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/COMPILE/compile_param_jeanzay.def	(revision 2211)
@@ -1,4 +1,4 @@
-arch = X64_JEANZAY
-mode = prod, debug
+arch = X64_JEANZAY_PGI
+mode = prod
 
 #arch = X64_JEANZAY_Intel, X64_JEANZAY_gcc,  X64_JEANZAY_pgi
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_jeanzay
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_jeanzay	(revision 2210)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test_jeanzay	(revision 2211)
@@ -1,5 +1,5 @@
 #!/bin/bash
 
-export arch=X64_JEANZAY
+export arch=X64_JEANZAY_PGI
 export mode=prod
 
@@ -7,6 +7,6 @@
 
 
-export arch=X64_JEANZAY
-export mode=debug
-
-bash ./run_test
+#export arch=X64_JEANZAY
+#export mode=debug
+#
+#bash ./run_test
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2210)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2211)
@@ -90,5 +90,5 @@
             fh.write("cp ../../build_"+arch+"_"+mode+"/bin/generic_testcase.exe ./\n")
             fh.write("source ../../build_"+arch+"_"+mode+"/arch.env\n")
-            fh.write("source $I_MPI_ROOT/intel64/bin/mpivars.sh release_mt\n")
+            #fh.write("source $I_MPI_ROOT/intel64/bin/mpivars.sh release_mt\n")
             fh.write("srun generic_testcase.exe")
 
@@ -151,5 +151,5 @@
             fh.write("cd ${SLURM_SUBMIT_DIR}\n")
             fh.write("source build_"+arch+"_"+mode+"/arch.env\n")
-            fh.write("source $I_MPI_ROOT/intel64/bin/mpivars.sh release_mt\n")
+            #fh.write("source $I_MPI_ROOT/intel64/bin/mpivars.sh release_mt\n")
             fh.write("export location="+os.getcwd()+"\n")
             fh.write("export log_location="+os.getcwd()+"\n")